#ifndef OSL_SHADOW_EFFECT_H
#define OSL_SHADOW_EFFECT_H
#include "osl/state/numEffectState.h"
namespace osl
{
  namespace container
  {
    class PieceVector;
  }
  namespace effect_util
  {
    using container::PieceVector;
    /**
     * 
     */
    struct ShadowEffect
    {
    private:
      template <int count_max>
      static int count(const NumEffectState&, Position target, 
		       Player attack);
    public:
      /**
       * target  attack αĤǤ⤢뤫
       * ɲˤоݤȤʤ
       */
      static bool hasEffect(const NumEffectState&, Position target, 
			    Player attack);
      /**
       * target  attack αĤޤǿ.
       * ɲζʹߤоݤȤʤ
       */
      static int count2(const NumEffectState&, Position target, 
			      Player attack);
    };
  } // namespace effect_util
  using effect_util::ShadowEffect;
} // namespace osl

#endif /* OSL_SHADOW_EFFECT_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
