/* ntesukiMoveList.h
 */
#ifndef _NTESUKI_MOVELIST_H
#define _NTESUKI_MOVELIST_H

#include "osl/ntesuki/ntesukiMove.h"
#include "osl/ntesuki/ntesukiExceptions.h"
#include "osl/state/numEffectState.h"
#include "osl/container/moveVector.h"
#include "osl/move_classifier/moveAdaptor.h"
#include "osl/move_classifier/check_.h"
#include "osl/stl/slist.h"
#include <cassert>
#include <algorithm>
#include <iterator>
#include <iosfwd>

namespace osl
{
  namespace ntesuki
  {
    // TODO: ٤
    typedef slist<NtesukiMove> NtesukiMoveListBase;
    /** 
     * ntesuki õǻȤؼΥꥹ
     */
    class NtesukiMoveList : public NtesukiMoveListBase
    {
    public:
      NtesukiMoveList();
      NtesukiMoveList(const NumEffectState& state,
		      const osl::MoveVector& mv);

      /**
       * ʣ򤷤ʤ褦˼ɲä᥽å.
       * @c move 뤫ɤܤäˤ
       * ˤ move ؤλȤ֤.
       * ʤäˤ @c move Ʊ osl::Move Ĥ褦
       * NtesukiMove ɲä.
       * Ԥ˴ط flags  record ξݻʤΤ.
       * ̾ɲäξˤ push_front Ѥ뤳.
       */
      NtesukiMove* add(const NtesukiMove& move);
      const NtesukiMove& find(const NtesukiMove& move) const;
    };
    std::ostream& operator<<(std::ostream&, const NtesukiMoveList&);
  } // namespace ntesukimate
} // namespace osl

#endif /* _NTESUKI_MOVELIST_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
