#include "osl/move_generator/allMoves.h"
#include "osl/move_generator/allMoves.tcc"

namespace osl
{
  template void move_generator::AllMoves<move_action::Store>::generateMoves<BLACK>(const NumEffectState&,move_action::Store&);
  template void move_generator::AllMoves<move_action::Store>::generateMoves<WHITE>(const NumEffectState&,move_action::Store&);

  namespace move_generator
  {
    // explicit template instantiation
    template struct AllMoves<move_action::Store>;
  } // namespace move_generator
} // namespace osl

void osl::GenerateAllMoves::
generate(Player p, const NumEffectState& state, container::MoveVector& out)
{
  typedef move_action::Store store_t;
  store_t store(out);
  move_generator::AllMoves<store_t>::generateMoves(p, state, store);
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
