#include "osl/move_generator/promote_.h"
#include "osl/move_generator/promote_.tcc"
#include "osl/move_action/store.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace move_generator
  {
    // explicit template instantiation
    template struct Promote<BLACK, move_action::Store,true>;
    template struct Promote<WHITE, move_action::Store,true>;

    template void osl::move_generator::Promote<(osl::Player)0, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)10>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)0, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)11>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)0, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)12>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)0, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)13>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)0, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)14>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)0, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)15>(NumEffectState const&, osl::move_action::Store&);

    template void osl::move_generator::Promote<(osl::Player)-1, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)10>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)-1, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)11>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)-1, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)12>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)-1, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)13>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)-1, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)14>(NumEffectState const&, osl::move_action::Store&);
    template void osl::move_generator::Promote<(osl::Player)-1, osl::move_action::Store, true>::generateMovesPtype<(osl::Ptype)15>(NumEffectState const&, osl::move_action::Store&);
  } // namespace move_generator
} // namespace osl
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
